use num_derive::FromPrimitive;

#[derive(Copy, Clone, FromPrimitive)]
pub(crate) enum OpCode {
	Pop,
	Print,
	Input,
	Literal8,
	Literal16,
	Nil,

	Var,
	NewVar,
	SetVar,

	Add,
	Sub,
	Mul,
	Div,
	Pow,
	Mod,
	Inc,

	Equal,
	Less,
	LessEqual,
	Greater,
	GreaterEqual,

	And,
	Or,

	Not,
	Minus,

	Jne,
	Jmp,
	JmpBack,

	Call,
	Native,
	Ret,
}
